'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var cn = _interopDefault(require('classnames'));
var CheckedIcon = _interopDefault(require('@alfalab/icons-classic/TickXsWhiteIcon'));
var IndeterminateIcon = _interopDefault(require('@alfalab/icons-classic/CheckIndeterminateSWhiteIcon'));

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
var __assign = function () {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s)
                if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
function __rest(s, e) {
    var t = {};
    for (var p in s)
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

var styles = {"component":"checkbox__component_1wq54","box":"checkbox__box_1wq54","checked":"checkbox__checked_1wq54","disabled":"checkbox__disabled_1wq54","indeterminate":"checkbox__indeterminate_1wq54","content":"checkbox__content_1wq54","label":"checkbox__label_1wq54","hint":"checkbox__hint_1wq54","indeterminateIcon":"checkbox__indeterminateIcon_1wq54"};
require('./index.css')

var Checkbox = React.forwardRef(function (_a, ref) {
    var _b;
    var checked = _a.checked, label = _a.label, hint = _a.hint, onChange = _a.onChange, className = _a.className, name = _a.name, disabled = _a.disabled, dataTestId = _a.dataTestId, _c = _a.indeterminate, indeterminate = _c === void 0 ? false : _c, restProps = __rest(_a, ["checked", "label", "hint", "onChange", "className", "name", "disabled", "dataTestId", "indeterminate"]);
    var handleChange = function (event) {
        if (onChange) {
            onChange(event, { checked: event.target.checked, name: name });
        }
    };
    return (
    // eslint-disable-next-line jsx-a11y/label-has-associated-control
    React__default.createElement("label", { className: cn(styles.component, className, (_b = {},
            _b[styles.disabled] = disabled,
            _b[styles.checked] = checked,
            _b[styles.indeterminate] = indeterminate,
            _b)), ref: ref },
        React__default.createElement("span", { className: styles.box },
            React__default.createElement("input", __assign({ type: 'checkbox', onChange: handleChange, disabled: disabled, checked: checked, "data-test-id": dataTestId }, restProps)),
            checked && React__default.createElement(CheckedIcon, null),
            indeterminate && !checked && (React__default.createElement(IndeterminateIcon, { className: styles.indeterminateIcon }))),
        (label || hint) && (React__default.createElement("span", { className: styles.content },
            label && React__default.createElement("span", { className: styles.label }, label),
            hint && React__default.createElement("span", { className: styles.hint }, hint)))));
});

exports.Checkbox = Checkbox;
