import React, { forwardRef } from 'react';
import cn from 'classnames';
import CheckedIcon from '@alfalab/icons-classic/TickXsWhiteIcon';
import IndeterminateIcon from '@alfalab/icons-classic/CheckIndeterminateSWhiteIcon';

var styles = {"component":"checkbox__component_1wq54","box":"checkbox__box_1wq54","checked":"checkbox__checked_1wq54","disabled":"checkbox__disabled_1wq54","indeterminate":"checkbox__indeterminate_1wq54","content":"checkbox__content_1wq54","label":"checkbox__label_1wq54","hint":"checkbox__hint_1wq54","indeterminateIcon":"checkbox__indeterminateIcon_1wq54"};
require('./index.css')

const Checkbox = forwardRef(({ checked, label, hint, onChange, className, name, disabled, dataTestId, indeterminate = false, ...restProps }, ref) => {
    const handleChange = (event) => {
        if (onChange) {
            onChange(event, { checked: event.target.checked, name });
        }
    };
    return (
    // eslint-disable-next-line jsx-a11y/label-has-associated-control
    React.createElement("label", { className: cn(styles.component, className, {
            [styles.disabled]: disabled,
            [styles.checked]: checked,
            [styles.indeterminate]: indeterminate,
        }), ref: ref },
        React.createElement("span", { className: styles.box },
            React.createElement("input", Object.assign({ type: 'checkbox', onChange: handleChange, disabled: disabled, checked: checked, "data-test-id": dataTestId }, restProps)),
            checked && React.createElement(CheckedIcon, null),
            indeterminate && !checked && (React.createElement(IndeterminateIcon, { className: styles.indeterminateIcon }))),
        (label || hint) && (React.createElement("span", { className: styles.content },
            label && React.createElement("span", { className: styles.label }, label),
            hint && React.createElement("span", { className: styles.hint }, hint)))));
});

export { Checkbox };
